Index: uspace/lib/clipboard/meson.build
===================================================================
--- uspace/lib/clipboard/meson.build	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/lib/clipboard/meson.build	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,29 @@
+#
+# Copyright (c) 2023 Jiri Svoboda
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+#
+# - Redistributions of source code must retain the above copyright
+#   notice, this list of conditions and the following disclaimer.
+# - Redistributions in binary form must reproduce the above copyright
+#   notice, this list of conditions and the following disclaimer in the
+#   documentation and/or other materials provided with the distribution.
+# - The name of the author may not be used to endorse or promote products
+#   derived from this software without specific prior written permission.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+# IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+# NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+# THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+#
+
+src = files('src/clipboard.c')
Index: uspace/lib/clipboard/src/clipboard.c
===================================================================
--- uspace/lib/clipboard/src/clipboard.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/lib/clipboard/src/clipboard.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,210 @@
+/*
+ * Copyright (c) 2023 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libclipboard
+ * @{
+ */
+/** @file
+ * @brief System clipboard API.
+ *
+ * The clipboard data is managed by the clipboard service and it is shared by
+ * the entire system.
+ *
+ */
+
+#include <async.h>
+#include <clipboard.h>
+#include <errno.h>
+#include <fibril_synch.h>
+#include <ipc/clipboard.h>
+#include <ipc/services.h>
+#include <loc.h>
+#include <stdlib.h>
+#include <str.h>
+
+static FIBRIL_MUTEX_INITIALIZE(clip_mutex);
+static async_sess_t *clip_sess = NULL;
+
+/** Start an async exchange on the clipboard session.
+ *
+ * @return New exchange.
+ *
+ */
+static async_exch_t *clip_exchange_begin(void)
+{
+	service_id_t sid;
+	errno_t rc;
+
+	fibril_mutex_lock(&clip_mutex);
+
+	while (clip_sess == NULL) {
+		rc = loc_service_get_id(SERVICE_NAME_CLIPBOARD, &sid,
+		    IPC_FLAG_BLOCKING);
+		if (rc != EOK)
+			continue;
+
+		clip_sess = loc_service_connect(sid, INTERFACE_CLIPBOARD,
+		    IPC_FLAG_BLOCKING);
+	}
+
+	fibril_mutex_unlock(&clip_mutex);
+
+	return async_exchange_begin(clip_sess);
+}
+
+/** Finish an async exchange on the clipboard session.
+ *
+ * @param exch Exchange to be finished.
+ *
+ */
+static void clip_exchange_end(async_exch_t *exch)
+{
+	async_exchange_end(exch);
+}
+
+/** Copy string to clipboard.
+ *
+ * Sets the clipboard contents to @a str. Passing an empty string or NULL
+ * makes the clipboard empty.
+ *
+ * @param str String to put to clipboard or NULL.
+ *
+ * @return Zero on success or an error code.
+ *
+ */
+errno_t clipboard_put_str(const char *str)
+{
+	size_t size = str_size(str);
+
+	if (size == 0) {
+		async_exch_t *exch = clip_exchange_begin();
+		errno_t rc = async_req_1_0(exch, CLIPBOARD_PUT_DATA,
+		    CLIPBOARD_TAG_NONE);
+		clip_exchange_end(exch);
+
+		return (errno_t) rc;
+	} else {
+		async_exch_t *exch = clip_exchange_begin();
+		aid_t req = async_send_1(exch, CLIPBOARD_PUT_DATA, CLIPBOARD_TAG_DATA,
+		    NULL);
+		errno_t rc = async_data_write_start(exch, (void *) str, size);
+		clip_exchange_end(exch);
+
+		if (rc != EOK) {
+			errno_t rc_orig;
+			async_wait_for(req, &rc_orig);
+			if (rc_orig == EOK)
+				return (errno_t) rc;
+			else
+				return (errno_t) rc_orig;
+		}
+
+		async_wait_for(req, &rc);
+
+		return (errno_t) rc;
+	}
+}
+
+/** Get a copy of clipboard contents.
+ *
+ * Returns a new string that can be deallocated with free().
+ *
+ * @param str Here pointer to the newly allocated string is stored.
+ *
+ * @return Zero on success or an error code.
+ *
+ */
+errno_t clipboard_get_str(char **str)
+{
+	/* Loop until clipboard read succesful */
+	while (true) {
+		async_exch_t *exch = clip_exchange_begin();
+
+		sysarg_t size;
+		sysarg_t tag;
+		errno_t rc = async_req_0_2(exch, CLIPBOARD_CONTENT, &size, &tag);
+
+		clip_exchange_end(exch);
+
+		if (rc != EOK)
+			return (errno_t) rc;
+
+		char *sbuf;
+
+		switch (tag) {
+		case CLIPBOARD_TAG_NONE:
+			sbuf = malloc(1);
+			if (sbuf == NULL)
+				return ENOMEM;
+
+			sbuf[0] = 0;
+			*str = sbuf;
+			return EOK;
+		case CLIPBOARD_TAG_DATA:
+			sbuf = malloc(size + 1);
+			if (sbuf == NULL)
+				return ENOMEM;
+
+			exch = clip_exchange_begin();
+			aid_t req = async_send_1(exch, CLIPBOARD_GET_DATA, tag, NULL);
+			rc = async_data_read_start(exch, (void *) sbuf, size);
+			clip_exchange_end(exch);
+
+			if ((errno_t) rc == EOVERFLOW) {
+				/*
+				 * The data in the clipboard has changed since
+				 * the last call of CLIPBOARD_CONTENT
+				 */
+				break;
+			}
+
+			if (rc != EOK) {
+				errno_t rc_orig;
+				async_wait_for(req, &rc_orig);
+				if (rc_orig == EOK)
+					return (errno_t) rc;
+				else
+					return (errno_t) rc_orig;
+			}
+
+			async_wait_for(req, &rc);
+
+			if (rc == EOK) {
+				sbuf[size] = 0;
+				*str = sbuf;
+			}
+
+			return rc;
+		default:
+			return EINVAL;
+		}
+	}
+}
+
+/** @}
+ */
Index: uspace/lib/clui/include/nchoice.h
===================================================================
--- uspace/lib/clui/include/nchoice.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/lib/clui/include/nchoice.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,76 @@
+/*
+ * Copyright (c) 2015 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libclui
+ * @{
+ */
+/**
+ * @file Numerical choice
+ */
+
+#ifndef LIBCLUI_NCHOICE_H_
+#define LIBCLUI_NCHOICE_H_
+
+#include <adt/list.h>
+#include <tinput.h>
+
+typedef enum {
+	/** This is the default option */
+	ncf_default = 1
+} nchoice_flag_t;
+
+typedef struct {
+	/** Link to nchoice_t.opts */
+	link_t lchoice;
+	/** Option text */
+	char *text;
+	/** User argument */
+	void *arg;
+} nchoice_opt_t;
+
+typedef struct {
+	/** Prompt text */
+	char *prompt;
+	/** Options */
+	list_t opts; /* of nchoice_opt_t */
+	/** Text input */
+	tinput_t *tinput;
+	/** Default option */
+	nchoice_opt_t *def_opt;
+} nchoice_t;
+
+extern errno_t nchoice_create(nchoice_t **);
+extern void nchoice_destroy(nchoice_t *);
+extern errno_t nchoice_set_prompt(nchoice_t *, const char *);
+extern errno_t nchoice_add(nchoice_t *, const char *, void *, nchoice_flag_t);
+extern errno_t nchoice_get(nchoice_t *, void **);
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/clui/include/tinput.h
===================================================================
--- uspace/lib/clui/include/tinput.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/lib/clui/include/tinput.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,165 @@
+/*
+ * Copyright (c) 2011 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libclui
+ * @{
+ */
+/**
+ * @file
+ */
+
+#ifndef LIBCLUI_TINPUT_H_
+#define LIBCLUI_TINPUT_H_
+
+#include <inttypes.h>
+#include <io/console.h>
+#include <stdio.h>
+
+#define HISTORY_LEN     10
+#define INPUT_MAX_SIZE  1024
+
+/** Begin enumeration of text completions.
+ *
+ * When user requests text completion, tinput will call this function to start
+ * text completion operation. @a *cstart should be set to the position
+ * (character index) of the first character of the 'word' that is being
+ * completed. The resulting text is obtained by replacing the range of text
+ * starting at @a *cstart and ending at @a pos with the completion text.
+ *
+ * The function can pass information to the get_next and fini functions
+ * via @a state. The init function allocates the state object and stores
+ * a pointer to it to @a *state. The fini function destroys the state object.
+ *
+ * @param text		Current contents of edit buffer (null-terminated).
+ * @param pos		Current caret position.
+ * @param cstart	Output, position in text where completion begins from.
+ * @param state		Output, pointer to a client state object.
+ *
+ * @return		EOK on success, error code on failure.
+ */
+typedef errno_t (*tinput_compl_init_fn)(char32_t *text, size_t pos, size_t *cstart,
+    void **state);
+
+/** Obtain one text completion alternative.
+ *
+ * Upon success the function sets @a *compl to point to a string, the
+ * completion text. The caller (Tinput) should not modify or free the text.
+ * The pointer is only valid until the next invocation of any completion
+ * function.
+ *
+ * @param state		Pointer to state object created by the init funtion.
+ * @param compl		Output, the completion text, ownership retained.
+ *
+ * @return		EOK on success, error code on failure.
+ */
+typedef errno_t (*tinput_compl_get_next_fn)(void *state, char **compl);
+
+/** Finish enumeration of text completions.
+ *
+ * The function must deallocate any state information allocated by the init
+ * function or temporary data allocated by the get_next function.
+ *
+ * @param state		Pointer to state object created by the init funtion.
+ */
+typedef void (*tinput_compl_fini_fn)(void *state);
+
+/** Text completion ops. */
+typedef struct {
+	tinput_compl_init_fn init;
+	tinput_compl_get_next_fn get_next;
+	tinput_compl_fini_fn fini;
+} tinput_compl_ops_t;
+
+/** Text input field (command line).
+ *
+ * Applications should treat this structure as opaque.
+ */
+typedef struct {
+	/** Console */
+	console_ctrl_t *console;
+
+	/** Prompt string */
+	char *prompt;
+
+	/** Completion ops. */
+	tinput_compl_ops_t *compl_ops;
+
+	/** Buffer holding text currently being edited */
+	char32_t buffer[INPUT_MAX_SIZE + 1];
+
+	/** Linear position on screen where the prompt starts */
+	unsigned prompt_coord;
+	/** Linear position on screen where the text field starts */
+	unsigned text_coord;
+
+	/** Screen dimensions */
+	sysarg_t con_cols;
+	sysarg_t con_rows;
+
+	/** Number of characters in @c buffer */
+	size_t nc;
+
+	/** Caret position within buffer */
+	size_t pos;
+
+	/** Selection mark position within buffer */
+	size_t sel_start;
+
+	/** History (dynamically allocated strings) */
+	char *history[HISTORY_LEN + 1];
+
+	/** Number of entries in @c history, not counting [0] */
+	size_t hnum;
+
+	/** Current position in history */
+	size_t hpos;
+
+	/** @c true if finished with this line (return to caller) */
+	bool done;
+
+	/** @c true if user requested to abort interactive loop */
+	bool exit_clui;
+
+	/** @c true if left shift key is currently held */
+	bool lshift_held;
+
+	/** @c true if right shift key is currently held */
+	bool rshift_held;
+} tinput_t;
+
+extern tinput_t *tinput_new(void);
+extern errno_t tinput_set_prompt(tinput_t *, const char *);
+extern void tinput_set_compl_ops(tinput_t *, tinput_compl_ops_t *);
+extern void tinput_destroy(tinput_t *);
+extern errno_t tinput_read(tinput_t *, char **);
+extern errno_t tinput_read_i(tinput_t *, const char *, char **);
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/clui/meson.build
===================================================================
--- uspace/lib/clui/meson.build	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/clui/meson.build	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 #
-# Copyright (c) 2010 Jiri Svoboda
+# Copyright (c) 2023 Jiri Svoboda
 # All rights reserved.
 #
@@ -27,6 +27,7 @@
 #
 
+deps = [ 'clipboard', 'console' ]
 src = files(
-	'nchoice.c',
-	'tinput.c',
+	'src/nchoice.c',
+	'src/tinput.c',
 )
Index: uspace/lib/clui/src/nchoice.c
===================================================================
--- uspace/lib/clui/src/nchoice.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/lib/clui/src/nchoice.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,200 @@
+/*
+ * Copyright (c) 2015 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+/** @addtogroup libclui
+ * @{
+ */
+/**
+ * @file Numerical choice
+ */
+
+#include <errno.h>
+#include <nchoice.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include <str.h>
+#include <tinput.h>
+
+/** Create numerical choice
+ *
+ */
+errno_t nchoice_create(nchoice_t **rchoice)
+{
+	nchoice_t *choice = NULL;
+	errno_t rc;
+
+	choice = calloc(1, sizeof(nchoice_t));
+	if (choice == NULL)
+		goto error;
+
+	list_initialize(&choice->opts);
+
+	choice->tinput = tinput_new();
+	if (choice->tinput == NULL)
+		goto error;
+
+	rc = tinput_set_prompt(choice->tinput, "Choice> ");
+	if (rc != EOK) {
+		assert(rc == ENOMEM);
+		goto error;
+	}
+
+	*rchoice = choice;
+	return EOK;
+error:
+	nchoice_destroy(choice);
+	return ENOMEM;
+}
+
+/** Destroy numerical choice */
+void nchoice_destroy(nchoice_t *choice)
+{
+	if (choice == NULL)
+		return;
+
+	tinput_destroy(choice->tinput);
+	free(choice);
+}
+
+/** Set numerica choice prompt text */
+errno_t nchoice_set_prompt(nchoice_t *choice, const char *prompt)
+{
+	char *pstr;
+
+	pstr = str_dup(prompt);
+	if (pstr == NULL)
+		return ENOMEM;
+
+	free(choice->prompt);
+	choice->prompt = pstr;
+	return EOK;
+}
+
+/** Add option to numerical choice */
+errno_t nchoice_add(nchoice_t *choice, const char *opttext, void *arg,
+    nchoice_flag_t flags)
+{
+	nchoice_opt_t *opt;
+	char *ptext;
+
+	opt = calloc(1, sizeof(nchoice_opt_t));
+	if (opt == NULL)
+		return ENOMEM;
+
+	ptext = str_dup(opttext);
+	if (ptext == NULL) {
+		free(opt);
+		return ENOMEM;
+	}
+
+	opt->text = ptext;
+	opt->arg = arg;
+	list_append(&opt->lchoice, &choice->opts);
+
+	if ((flags & ncf_default) != 0) {
+		/* Set this option as the default */
+		assert(choice->def_opt == NULL);
+
+		choice->def_opt = opt;
+	}
+
+	return EOK;
+}
+
+/** Get numerical choice from user */
+errno_t nchoice_get(nchoice_t *choice, void **rarg)
+{
+	int i;
+	errno_t rc;
+	int ret;
+	char *str;
+	unsigned long c;
+	char *eptr;
+	char *istr;
+	int def_i;
+
+again:
+	printf("%s\n", choice->prompt);
+
+	def_i = 0;
+	i = 1;
+	list_foreach(choice->opts, lchoice, nchoice_opt_t, opt) {
+		printf("%d: %s%s\n", i, opt->text, opt == choice->def_opt ?
+		    " [default]" : "");
+		if (opt == choice->def_opt)
+			def_i = i;
+		++i;
+	}
+
+	if (def_i > 0) {
+		ret = asprintf(&istr, "%d", def_i);
+		if (ret < 0)
+			return ENOMEM;
+	} else {
+		istr = str_dup("");
+		if (istr == NULL)
+			return ENOMEM;
+	}
+
+	rc = tinput_read_i(choice->tinput, istr, &str);
+	free(istr);
+
+	if (rc != EOK) {
+		assert(rc == EIO || rc == ENOENT);
+
+		if (rc == ENOENT) {
+			return ENOENT;
+		} else {
+			/* rc == EIO */
+			return EIO;
+		}
+	}
+
+	c = strtoul(str, &eptr, 10);
+	if (*eptr != '\0' || c < 1 || c > (unsigned long)i - 1) {
+		printf("Invalid choice. Try again.\n");
+		free(str);
+		goto again;
+	}
+
+	free(str);
+
+	i = 1;
+	list_foreach(choice->opts, lchoice, nchoice_opt_t, opt) {
+		if ((unsigned long)i == c) {
+			*rarg = opt->arg;
+			return EOK;
+		}
+		++i;
+	}
+
+	assert(false);
+	return ENOENT;
+}
+
+/** @}
+ */
